import requests


class Proxy:

    def __init__(self, name, url, port, usr=None, pwd=None):

        # Necessary
        self.name = name
        self.url = url
        self.port = port

        # Optional
        self.usr = usr
        self.pwd = pwd

        # Created on selftest
        self.incoming = None
        self.ip = None
        self.session = None
        self.isworking = None

        # Running Proxy selftest
        self.test()

    def test(self):

        # print(f'http://{self.usr}:{self.pwd}@{self.url}:{self.port}')

        self.session = requests.Session()
        url = "https://api.ipify.org/"

        if self.usr:
            proxies = {
                'http': f'http://{self.usr}:{self.pwd}@{self.url}:{self.port}',
                'https': f'http://{self.usr}:{self.pwd}@{self.url}:{self.port}'
            }
        else:
            proxies = {
                'http': f'http://{self.url}:{self.port}',
                'https': f'http://{self.url}:{self.port}'
            }

        print(f"[DEBUG] {proxies}")

        headers = {
            'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) '
                          'Chrome/86.0.4240.183 Safari/537.36'
        }

        try:
            self.session.headers = headers

            # Check incoming ip
            r = self.session.get(url)
            self.incoming = r.text

            # Check proxied ip
            self.session.proxies = proxies
            r = self.session.get(url)

            if r.status_code == 200:
                self.ip = r.text
                # print(f"DEBUG: Proxied {incoming} to {self.ip}")
                self.isworking = True
            else:
                print(r.text)
                self.isworking = False

            # print(f"DEBUG: Statuscode: {r.status_code}\nDEBUG: Good Proxy: {self.isworking}")

        except Exception as e:
            print(f"[DEBUG] Connection Error | (check proxy settings)\n[DEBUG] {e}")
            self.isworking = False

    def testurl(self, siteobj):

        self.session.headers = siteobj.headers
        url = siteobj.register

        print(f"Starting URL Test {url}")
        print(self.isworking)
        print(self.session)
        if self.isworking:
            r = self.session.get(url, timeout=10)
            print(r)
            data = r.text
            print(data)
